
/* "past2 extends water" means that there are a lot
	of routines in water.java that this applet imports
	and uses, so if you want to understand this code,
	read and understand water.java first.

	The routines in this file replace those in water.java
	that have the same names. This is called "class inheritance".
	This allows a small amount of code to slightly modify
	existing programs that can be very large.

	Anyway. This is my bit for Java toy-making. I am Neal McDonald,
	this is my code, take and eat, but leave in a pointer to me:
	www.workly.com
	*/

import java.applet.*;
import java.awt.*;
import java.awt.image.*;


public class past2 extends water {

	 static int OC = 9;
	 static int RAD = 10;

	void r_fillOval(Graphics gr, int x, int y, int w, int h) {
		gr.fillOval(x,y,w,h);
	}


	void initPart(int which) {
		int r, g, b;
		double gx, gy;

		gx = (Math.random() * imageX * imageXscale)+ imageXoffset;
		gy = (Math.random() * imageY * imageYscale)+ imageYoffset;

		parts[which][XPOS] = gx;
		parts[which][YPOS] = gy;
		parts[which][DIR] = Math.random() *360;
		parts[which][UPD] = Math.random() *20;

		parts[which][OX] = gx;
		parts[which][OY] = gy;
		parts[which][OC] = 0.0;
		parts[which][SPEED] = 3.0;
		parts[which][RAD] = 0.0;

		partColors[which] = getColorC((int)gx, (int)gy);
	}

	void drawPart(Graphics gr, int which) {
		int px,py,ox,oy,  cx, cy, r;
		double c, dc;

		px = ((int)parts[which][XPOS]);
		py = ((int)parts[which][YPOS]);
		ox = ((int)parts[which][OX]);
		oy = ((int)parts[which][OY]);

		r=getColorG(px, py);

		c = (double)r;
		dc = c - parts[which][OC];
		if (dc<0.0) { dc = 0.0-dc; }

		if ((dc>60.0) && (parts[which][RAD]<4.0)) {
			partColors[which] = new Color(r, r, r);
			parts[which][RAD] = 12.0;
		}
		parts[which][OC] = c;

		if (parts[which][RAD] > 3.0) {
			parts[which][RAD]-=1.2;
		}
		dc = parts[which][RAD];
		ox = (int)(dc);
		oy = (int)(dc*.5);


		if ( (px>imageXoffset) &&
			(py>imageYoffset) &&
			(px<((imageXscale*imageX)+imageXoffset)) &&
			(py<((imageYscale* imageY)+imageYoffset)) ) {
			r_setColor(gr, partColors[which]);
			r_fillOval(gr, px-oy,py-oy, ox,ox);
		}
	}
}